二分答案找最优解 codeforces problem/551/C GukiZ hates Boxes

来源:互联网 发布:c语言短信接口代码 编辑:程序博客网 时间:2024/04/28 04:21

题址:http://codeforces.com/problemset/problem/551/C

C. GukiZ hates Boxes
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are n piles of boxes, arranged in a line, from left to right, i-th pile (1 ≤ i ≤ n) containing ai boxes. Luckily, m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

  1. If i ≠ n, move from pile i to pile i + 1;
  2. If pile located at the position of student is not empty, remove one box from it.

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time t in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after t seconds, but all the boxes must be removed.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 105), the number of piles of boxes and the number of GukiZ's students.

The second line contains n integers a1, a2, ... an (0 ≤ ai ≤ 109) where ai represents the number of boxes on i-th pile. It's guaranteed that at least one pile of is non-empty.

Output

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

Examples
input
2 11 1
output
4
input
3 21 0 2
output
5
input
4 1003 4 5 4
output
5
Note

First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.

题意:1--n上有若干箱子,现在有学生m名。学生都在0处,每走一个单位需要1分钟,每搬一个箱子需要1分钟,问把所有箱子搬完最少需要多少分钟?

 

思路:假设需要k分钟,我们可以模拟出k分钟每个学生走的路和搬的箱子数量,看是否每个人都干活了,如果有学生没干活,箱子都搬完了,说明k偏大,减小k继续模拟。如果每个人都干活k分钟箱子还没搬完,说明k分钟不够,增加k继续模拟;

这题用二分答案找最优解。

设t为最后一个有箱子的位置。sum为箱子总数。

k的范围是(t+1,sum+t);

AC代码:

#include<iostream>#include<cstdio>#include<cstdlib>#include<cstring>#include<algorithm>#include<cmath>#include<queue>#include<map>#include<string>#define LL long long int#define inf 0x3f3f3f3f#define N 1000010using namespace std;int a[100050];int n,m,t;LL sum,k;bool check(LL x){    sum=0;    k=m;    for(int i=1;i<=t;i++)    {        sum+=a[i];        while(sum+i>=x)        {            sum-=x-i;            k--;            if(k<0)return 0;        }    }    if(k==0) return sum<=0;    return 1;}int main(){    scanf("%d%d",&n,&m);    for(int i=1;i<=n;i++)    {        scanf("%d",&a[i]);        sum+=a[i];        if(a[i])            t=i;    }    LL l=t+1,r=sum+t,mid;    while(l<=r)    {        mid=(l+r)/2;        if(check(mid)) r=mid-1;        else l=mid+1;    }    printf("%lld\n",l);}






0 0
原创粉丝点击